﻿using System;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

//namespace PictureSimilarityJudgmentBySukiyakitti {※namespaceは省略
public partial class Form1 : Form {
//□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□
    #region 処理全般        
    private DateTime cBeforeDateTime;//各処理の処理前時刻を格納する変数。
    private int cDoneCnt = 0;//処理した数を格納する変数。
    float cFloatThreshold;//しきい値入力の値をfloat型にしたもの。
    Size cGeneralWindowSize;//処理中タブ以外選択中の画面サイズ
    int cCompDispLimit;//比較グリッドの表示数上限
    string[] cGraphicExtensionArray = new string[0];//画像の拡張子を格納。

    public Form1() {
        InitializeComponent();
        this.Text += " Ver" + System.Reflection.Assembly.GetExecutingAssembly().GetName().Version;
        cGeneralWindowSize = this.Size;
        cmbStttOmit.Items.AddRange(new string[]{ "1", "2", "3", "4", "8"});
        cmbStttOmit.SelectedIndex = 1;//※設定ファイル読込失敗時の選択肢
        cmbStttSection.Items.AddRange(new string[] { "1", "2", "3", "4", "5" });
        cmbStttSection.SelectedIndex = 1;//※設定ファイル読込失敗時の選択肢
        cmbProcPriority.Items.AddRange(new string[]{ "Idle", "BelowNormal", "Normal", "AboveNormal", "High", "RealTime" });
        cmbProcPriority.SelectedIndex = 2;
        fReadSetting();         
    }

    //実行ボタン押下。処理全体の管理も行う。
    private void btnMakeSttt_Click(object sender, EventArgs e) {
        try {
            fControlInit();
            //しきい値テキストの数値チェック　兼　数値型に格納。
            if (float.TryParse(txtThreshold.Text, out cFloatThreshold) == false) {
                MessageBox.Show("しきい値の数値変換失敗"); return; }
            //処理優先度変更            
            Process lThisProcess = System.Diagnostics.Process.GetCurrentProcess();
            switch (cmbProcPriority.SelectedItem.ToString()) {
                case        "Idle": lThisProcess.PriorityClass = ProcessPriorityClass.Idle; break;
                case "BelowNormal": lThisProcess.PriorityClass = ProcessPriorityClass.BelowNormal; break;
                case      "Normal": lThisProcess.PriorityClass = ProcessPriorityClass.Normal; break;
                case "AboveNormal": lThisProcess.PriorityClass = ProcessPriorityClass.AboveNormal; break;
                case        "High": lThisProcess.PriorityClass = ProcessPriorityClass.High; break;
                case    "RealTime": lThisProcess.PriorityClass = ProcessPriorityClass.RealTime; break;
                default: lThisProcess.PriorityClass = ProcessPriorityClass.Normal; break;
            }

            tabControl.SelectedIndex = 4;//処理中タブに移動。            
            fSetStttCol(ref dgrBase); fSetStttCol(ref dgrDest);//統計データグリッド２種の列生成。
            //ベース統計の作成            
            lblProgress.Text = "ベース統計";
            cBeforeDateTime = DateTime.Now;
            if ( fSetSttt_Branch(txtBasePath.Text, ref dgrBase, ref lblBaseRoot) == false) return;
            txtLog.Text += "ベース統計：" + fFormatTimeSpan(DateTime.Now - cBeforeDateTime);
            //ベース統計以降の処理方法は、比較方法により分岐。 
            if (lblCompMethod_Base.BackColor == Color.Khaki) { 
                lblProgress.Text = "比較結果";
                cBeforeDateTime = DateTime.Now;
                fCompare_BetweenBase();
                txtLog.Text += "比較結果：" + fFormatTimeSpan(DateTime.Now - cBeforeDateTime);
            } else {
                lblProgress.Text = "比較先統計";
                cBeforeDateTime = DateTime.Now;
                if( fSetSttt_Branch(txtDestPath.Text, ref dgrDest, ref lblDestRoot) == false) return;
                txtLog.Text += "比較先統計：" + fFormatTimeSpan(DateTime.Now - cBeforeDateTime);

                lblProgress.Text = "比較結果";
                cBeforeDateTime = DateTime.Now;
                fCompare_BaseAndDest();
                txtLog.Text += "比較結果：" + fFormatTimeSpan(DateTime.Now - cBeforeDateTime).ToString();
            }
            //比較結果のソート、No記入
            dgrComp.Sort(dgrComp.Columns[1], System.ComponentModel.ListSortDirection.Ascending);
            for (int i = 0; i < dgrComp.RowCount; i++) {
                dgrComp.Rows[i].Cells[0].Value = i + 1;
            }            
            //比較結果のヘッダー名の一部は可変
            dgrComp.Columns[2].HeaderText = lblCompMethod_Base.BackColor == Color.Khaki ? "ベース１" : "ベース";
            dgrComp.Columns[3].HeaderText = lblCompMethod_Base.BackColor == Color.Khaki ? "ベース２" : "比較先"; 

            fAfterProc();
        } catch (Exception ex) {
            fErrCatch("処理全体管理関数にてエラー", ex);
        } finally {
            tabControl.SelectedIndex = 0;
        }
    }
    //設定ファイル読み込み用サブ関数
    public void fReadSetting() {
        System.IO.StreamReader lStream = null;
        System.IO.StringReader lRead = null;
        string lTempStr;
        try {
            //ファイルを開き、読み取りデータを確保。
            //　※ファイル存在チェックは不要。無ければ「【ファイルのフルパス】が見つかりませんでした」的なメッセージが出る。
            lStream = new System.IO.StreamReader("PictureSimilarityJudgmentBySukiyakitti.txt", System.Text.Encoding.Default);
            lRead = new System.IO.StringReader(lStream.ReadToEnd());
            lStream.Close();
            lStream.Dispose();
            //１行目：画像の拡張子
            cGraphicExtensionArray = lRead.ReadLine().Split(',');
            //２行目：しきい値の初期値
            txtThreshold.Text = lRead.ReadLine();
            //３行目：省略度の初期値
            fSetComboBySetting(cmbStttOmit, lRead.ReadLine());
            //４行目：処理優先度の初期値
            fSetComboBySetting(cmbProcPriority, lRead.ReadLine());
            //５行目：比較グリッドの表示上限数
            lTempStr = lRead.ReadLine();
            if (int.TryParse(lTempStr, out cCompDispLimit) == false) {
                MessageBox.Show("比較グリッド表示数上限が不正、１０００にしておく");
                cCompDispLimit = 1000;
            }
            //６行目：統計区画数
            fSetComboBySetting(cmbStttSection, lRead.ReadLine());
        }
        catch (Exception ex) {
            fErrCatch("設定ファイル読み込み時にエラー", ex);
            if (lStream != null) {
                try { lStream.Close()  ; } catch { }
                try { lStream.Dispose(); } catch { }
            }
        }
    }
    //処理時間表示を読みやすくする用。
    private string fFormatTimeSpan(TimeSpan aSpan) {
        string RetVal = "";
        RetVal += aSpan.Hours.ToString() + " 時間 ";
        RetVal += aSpan.Minutes.ToString() + " 分 ";
        RetVal += aSpan.Seconds.ToString() + " 秒 ";
        RetVal += aSpan.Milliseconds.ToString() + " ミリ " + "\r\n";
        return RetVal;
    }
    //エラーキャッチ時の処理を共通化したもの
    private void fErrCatch(string aExplain, Exception ex) {
        txtLog.BackColor = Color.MistyRose;
        txtLog.Text += aExplain + "\r\n";
        txtLog.Text += "概要：" + ex.Message + "\r\n";

        txtTrace.Text += ex.StackTrace + "\r\n";
    }
    //コンボボックスの選択肢設定用。
    private void fSetComboBySetting(ComboBox aCmb, string aStr) {
        try {
            foreach (var i in aCmb.Items) if (i.ToString() == aStr) aCmb.SelectedItem = i;
        } catch {
            txtTrace.Text += "コンボボックスの選択肢設定時にエラー。対象：" + aCmb.Name + "、設定値：" + aStr + "\r\n";
        }
    }
    //セルの値をString型にするコードの短縮用。
    private string fCellStr(DataGridView aGrid , int aRow, string aCol) { return aGrid.Rows[aRow].Cells[aCol].Value.ToString(); }
    //各コントロール初期化処理を共通化
    private void fControlInit() {
        cDoneCnt = 0;
        txtLog.BackColor = SystemColors.Window;
        txtLog.Text = "";
        txtTrace.Text = "";
        dgrBase.Rows.Clear();
        dgrDest.Rows.Clear();
        dgrComp.Rows.Clear();
        lblBaseRoot.Text = "";
        lblDestRoot.Text = "";
        picStttBase.Image = null;
        picStttDest.Image = null;
        picCompBase.Image = null;
        picCompDest.Image = null;
    }
    //後処理を共通化
    private void fAfterProc() {
        if (dgrBase.RowCount > 0) {
            dgrBase.Rows[0].Cells[0].Selected = true;
            fDispStttImage(dgrBase, lblBaseRoot, picStttBase); }
        if (dgrDest.RowCount > 0) {
            dgrDest.Rows[0].Cells[0].Selected = true;
            fDispStttImage(dgrDest, lblDestRoot, picStttDest); }
        if(dgrComp.RowCount > 0) {
            dgrComp.Rows[0].Cells[0].Selected = true;
            dgrComp_SelectionChanged(null, null);
        }
        lblProgress.Text = "処理完了";
    }
    #endregion//処理全般
//□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□
    #region 統計 
    //統計結果グリッド２種の列構成の生成。
    private void fSetStttCol(ref DataGridView aGrid) {
        aGrid.Columns.Clear();
        //１列目
        aGrid.Columns.Add("No.", "No.");
        aGrid.Columns[0].Width = 30;
        aGrid.Columns[0].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
        aGrid.Columns[0].Frozen = true;
        //２列目
        aGrid.Columns.Add("Name","Name");
        aGrid.Columns[1].Width = 150;
        aGrid.Columns[1].Frozen = true;
        //３列目以降
        int lSecCnt = int.Parse(cmbStttSection.Text);
        for (int y= 1; y <= lSecCnt; y++) {
            for (int x = 1; x <= lSecCnt; x++) {
                string lNameBase = y.ToString() + "_" + x.ToString() + "_";
                fAddStttValCol(ref aGrid, "R", lNameBase);
                fAddStttValCol(ref aGrid, "G", lNameBase);
                fAddStttValCol(ref aGrid, "B", lNameBase);
            }
        }
    }
    //統計グリッドの３列目以降（各値の列）追加用
    private void fAddStttValCol(ref DataGridView aGrid, string aRGB, string lNameBase)  {
        aGrid.Columns.Add(lNameBase + aRGB, lNameBase + aRGB);
        aGrid.Columns[aGrid.Columns.Count - 1].Width = 60;
        aGrid.Columns[aGrid.Columns.Count - 1].DefaultCellStyle.Format = "0.0000";
        aGrid.Columns[aGrid.Columns.Count - 1].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
    }
    //指定されたパスがフォルダかファイルかによる分岐等
    private bool fSetSttt_Branch(string aMakeTarget, ref DataGridView aGrid, ref Label aRootLabel) {
        //フォルダの場合、画像・読込対象の有無をチェックして分岐
        if (Directory.Exists(aMakeTarget)) {
            //以降の処理にて、aMakeTargetの末尾の\が有る場合・無い場合双方対応しようとすると冗長になるため、\は抜いておく。
            if (aMakeTarget.Substring(aMakeTarget.Length - 1) == "\\")
                aMakeTarget = aMakeTarget.Substring(0, aMakeTarget.Length - 1);

            bool lIsGraphicExists = false;
            //画像ファイルが有るか確認
            string[] lMakePathList = Directory.GetFiles(aMakeTarget, "*", SearchOption.AllDirectories);
            foreach (string lEachPath in lMakePathList) {
                if(lIsGraphicExists == false) //１つでも存在するのが分かったら、もうチェックする必要はない。
                    if (fIsGraphic(lEachPath) == true) {
                        lIsGraphicExists = true;
                        break; } }
            if (lIsGraphicExists) {
                aRootLabel.Text = aMakeTarget;
                int lDoneCnt = 0;
                lblAmount.Text = lMakePathList.Length.ToString("");
                foreach (string lEachPath in lMakePathList) {
                    fMakeEachSttt(ref aGrid, lEachPath, lEachPath.Replace(aMakeTarget, "").Substring(1));
                    lDoneCnt += 1;
                    lblDone.Text = lDoneCnt.ToString();
                    Application.DoEvents();
                }
            } else {
                txtLog.Text += "指定先フォルダ内に対象ファイル無し" + "\r\n";
                return false;
            }
        //ファイルの場合
        } else if (File.Exists(aMakeTarget)) {
            if (fIsGraphic(aMakeTarget) == true) {
                aRootLabel.Text = System.IO.Path.GetDirectoryName(aMakeTarget);
                fMakeEachSttt(ref aGrid, aMakeTarget, System.IO.Path.GetFileName(aMakeTarget));
            } else {
                txtLog.Text += "指定ファイルは画像ではない" + "\r\n";
                return false;
            }
        } else {
            txtLog.Text += "フォルダ（またはファイル）が不正（またはアクセス不可）" + "\r\n";
            return false;
        }
        return true;
    }
    //画像かどうか判定
    private bool fIsGraphic(string aPath) {
        string lExt = Path.GetExtension(aPath).Substring(1);
        foreach ( var each in cGraphicExtensionArray) if (lExt == each) return true;
        return false;
    }
    //各画像ファイル毎の統計結果を作成
    private void fMakeEachSttt(ref DataGridView aGrid, string aFullPath, string aDispName) {
        short lSecCnt = short.Parse(cmbStttSection.Text);//画像を縦横何区画に分けるか。数値化処理時間の節約のため、数値型で持っておく。
        short lSkipCnt = short.Parse(cmbStttOmit.SelectedItem.ToString());//ドットを読み飛ばす数。〃
        var lSumR = new int[lSecCnt, lSecCnt];
        var lSumG = new int[lSecCnt, lSecCnt];
        var lSumB = new int[lSecCnt, lSecCnt];
        var lRead = new int[lSecCnt, lSecCnt];//（各区画毎の）読み取ったドットの数。
        //予め行を追加しておく。ついでに行番号とファイル名の設定。
        aGrid.Rows.Add();
        var lRowAryNo = aGrid.RowCount - 1;
        aGrid.Rows[lRowAryNo].Cells[0].Value = aGrid.Rows.Count;
        aGrid.Rows[lRowAryNo].Cells[1].Value = aDispName;
        //各区画・色素毎の合計数の計算と、読んだドット数の把握。
        Bitmap lBitmap = new Bitmap(aFullPath);
        Color lEachPixel;
        for (int y = 0; y * lSkipCnt < lBitmap.Height; y++) {
            var lAryNo_Y = (short)Math.Truncate(((float)(y * lSkipCnt) / lBitmap.Height) * lSecCnt);
            for (int x = 0; x * lSkipCnt < lBitmap.Width; x++) {
                var lAryNo_X =(short)Math.Truncate(((float)(x * lSkipCnt) / lBitmap.Width) * lSecCnt);
                lEachPixel = lBitmap.GetPixel(x * lSkipCnt, y * lSkipCnt);
                lSumR[lAryNo_X, lAryNo_Y] += lEachPixel.R;
                lSumG[lAryNo_X, lAryNo_Y] += lEachPixel.G;
                lSumB[lAryNo_X, lAryNo_Y] += lEachPixel.B;
                lRead[lAryNo_X, lAryNo_Y] += 1;
            }
        }
        //上記データを元に各色素の平均を計算し、追加行に格納する。
        int lColNo = 1;
        for(int y = 0; y < lSecCnt; y++) {
            for(int x = 0; x < lSecCnt; x++) {
                lColNo++; aGrid.Rows[lRowAryNo].Cells[lColNo].Value = fEditStttVal(lSumR[x, y], lRead[x, y]);
                lColNo++; aGrid.Rows[lRowAryNo].Cells[lColNo].Value = fEditStttVal(lSumG[x, y], lRead[x, y]);
                lColNo++; aGrid.Rows[lRowAryNo].Cells[lColNo].Value = fEditStttVal(lSumB[x, y], lRead[x, y]);
            }
        }
    }    
    //統計結果の値の編集。０割対策→割り算→小数点４桁にする→floatで返す。
    private float fEditStttVal(int aRGB, int aRead) {
        if (aRead == 0) return 0;
        decimal RetVal = (decimal)aRGB / aRead;
        RetVal = Math.Truncate(RetVal* 10000) /10000;
        return (float)RetVal;
    }
    #endregion//統計
//□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□
    #region 比較
    //比較方法「ベース同士」の、各ファイル毎のループ
    private void fCompare_BetweenBase() {
        lblAmount.Text = ((dgrBase.RowCount * (dgrBase.RowCount - 1)) / 2).ToString();
        lblDone.Text = "0";
        for (int i = 0; i < dgrBase.RowCount; i++)
            for (int j = i + 1; j < dgrBase.RowCount; j++) 
                if (fAddCompRow(dgrBase, i, dgrBase, j) == false) return;
    }
    //比較方法「比較先と」の、各ファイル毎のループ
    private void fCompare_BaseAndDest() {
        lblAmount.Text = (dgrBase.RowCount * dgrDest.RowCount).ToString();
        lblDone.Text = "0";
        for (int i = 0; i < dgrBase.RowCount; i++)
            for (int j = 0; j < dgrDest.RowCount; j++)
                if (fAddCompRow(dgrBase, i, dgrDest, j) == false) return;        
    }
    //比較結果の追加。　戻り値について：比較結果表示数上限に達した→falseを返す→遷移元にて比較処理中断。
    private bool fAddCompRow(DataGridView aGrid1, int aRow1, DataGridView aGrid2, int aRow2) {
        float lFloatDiff = 0;
        for (int col = 2; col < aGrid1.Columns.Count; col++)
            lFloatDiff += Math.Abs(float.Parse(aGrid1.Rows[aRow1].Cells[col].Value.ToString())
                                 - float.Parse(aGrid2.Rows[aRow2].Cells[col].Value.ToString()) );
        lFloatDiff = lFloatDiff / (aGrid1.Columns.Count - 1);
        if (lFloatDiff <= cFloatThreshold) {
            dgrComp.Rows.Add();
            //差異値は小数点４桁までにする。理由：過度な精度は役に立たないし、読みにくくなる。
            lFloatDiff = (float)(Math.Truncate(lFloatDiff * 10000) /10000);
            //※１列目（No.）は現時点では分からない。全行記入してソートし直してから分かる。
            dgrComp.Rows[dgrComp.RowCount - 1].Cells[1].Value = lFloatDiff;
            dgrComp.Rows[dgrComp.RowCount - 1].Cells[2].Value = fCellStr(aGrid1, aRow1, "Name");
            dgrComp.Rows[dgrComp.RowCount - 1].Cells[3].Value = fCellStr(aGrid2, aRow2, "Name");
            if (dgrComp.RowCount >= cCompDispLimit) {
                MessageBox.Show("比較結果表示数が上限（" + cCompDispLimit.ToString() + "）を超えたため、比較表示を中断します。");
                return false;
            }
        }
        //画面の完了数の更新、１ＵＰ毎に画面上の値更新するのは処理時間的に良くないため、１００ＵＰ毎にする。
        cDoneCnt += 1;
        if (cDoneCnt % 100 == 0) { lblDone.Text = cDoneCnt.ToString(); Application.DoEvents(); }
        return true;
    }
    #endregion//比較
//□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□
    #region ＵＩ
    //ベース入力枠に、ドラッグアンドドロップでパスを渡す。
    //参考：it-confiado.com/blog/ドラッグアンドドロップでパスを渡す/
    private void txtBaseMake_DragDrop(object sender, DragEventArgs e) {
        if (!e.Data.GetDataPresent(DataFormats.FileDrop)) return;
        string[] dragFilePathArr = (string[])e.Data.GetData(DataFormats.FileDrop, false);
        txtBasePath.Text = dragFilePathArr[0];
    }
    private void txtBaseMake_DragEnter(object sender, DragEventArgs e) { e.Effect = DragDropEffects.All; }
    //比較先入力枠に、ドラッグアンドドロップでパスを渡す。
    private void txtDestMake_DragDrop(object sender, DragEventArgs e) {
        if (!e.Data.GetDataPresent(DataFormats.FileDrop)) return;
        string[] dragFilePathArr = (string[])e.Data.GetData(DataFormats.FileDrop, false);
        txtDestPath.Text = dragFilePathArr[0];
    }
    private void txtDestMake_DragEnter(object sender, DragEventArgs e) { e.Effect = DragDropEffects.All; }
    //操作タブの比較方法、押した方の色を強調色にする。
    private void lblCompMethod_Base_Click(object sender, EventArgs e) {
        lblCompMethod_Base.BackColor = Color.Khaki;
        lblCompMethod_Dest.BackColor = Color.LightGray;
    }
    //同上
    private void lblCompMethod_Dest_Click(object sender, EventArgs e) {
        lblCompMethod_Base.BackColor = Color.LightGray;
        lblCompMethod_Dest.BackColor = Color.Khaki;
    }
    //統計結果グリッドのセル選択変更時。サムネイルを表示。
    private void dgrBase_SelectionChanged(object sender, EventArgs e) { fDispStttImage(dgrBase, lblBaseRoot, picStttBase); }
    private void dgrDest_SelectionChanged(object sender, EventArgs e) { fDispStttImage(dgrDest, lblDestRoot, picStttDest); }
    private void fDispStttImage(DataGridView aGrid, Label aRootLabel, PictureBox aPic) {
        try {
            if (aGrid.SelectedCells.Count < 1) return;
            var aRowNo = aGrid.SelectedCells[0].RowIndex;//選択行番号、直接↓に入れるとややこしいので、一旦別変数に格納。
                aPic.Image = fCreateImage(aRootLabel.Text + "/" +
                    aGrid.Rows[aRowNo].Cells["Name"].Value.ToString());
            
        } catch { }//エラー対策はfCreateImageで行うため、こちらは省略。
    }
    //比較結果グリッドのセル選択変更時。サムネイルを表示。
    private void dgrComp_SelectionChanged(object sender, EventArgs e) {
        try {
            if (dgrComp.SelectedCells.Count < 1) return;
            var aRowNo = dgrComp.SelectedCells[0].RowIndex;//選択行番号、直接↓に入れるとややこしいので、一旦別変数に格納。
            picCompBase.Image = fCreateImage(lblBaseRoot.Text + "/" +
                dgrComp.Rows[aRowNo].Cells[2].Value.ToString());
            //比較の右側は、比較方法により処理が異なる。ベース同士の比較の場合は比較先に値は無く、ベースから取得。 
            //if (lblDestRoot.Text.Trim() == "") {
            //    picCompDest.Image = fCreateImage(lblBaseRoot.Text + "/" + dgrComp.Rows[aRowNo].Cells[3].Value.ToString());
            //} else {
            //    picCompDest.Image = fCreateImage(lblDestRoot.Text + "/" + dgrComp.Rows[aRowNo].Cells[3].Value.ToString());
            //}
            picCompDest.Image = lblDestRoot.Text.Trim() == "" ?
                 fCreateImage(lblBaseRoot.Text + "/" + dgrComp.Rows[aRowNo].Cells[3].Value.ToString()) :
                 fCreateImage(lblDestRoot.Text + "/" + dgrComp.Rows[aRowNo].Cells[3].Value.ToString());
        } catch { }//エラー対策はfCreateImageで行うため、こちらは省略。
    }
    //画像ファイルをロックしずに表示するための関数。
    //参考：https://dobon.net/vb/dotnet/graphics/drawpicture2.html
    public Image fCreateImage(string filename) {
        try {
            FileStream fs = new FileStream(filename, FileMode.Open, FileAccess.Read);
            Image img = Image.FromStream(fs);
            fs.Close();
            return img;
        } catch (Exception ex) {
            txtTrace.Text += "画像読込失敗。パス" + filename + "。内容：" + ex.ToString() + "\r\n" ;
            return null;
        }
    }
    //ログ表示枠のクリア
    private void btnLogClear_Click(object sender, EventArgs e) { txtLog.Text = ""; txtTrace.Text = ""; }
    //タブ移動時の挙動。
    private void tabControl_SelectedIndexChanged(object sender, EventArgs e) {
        //データグリッドを持つタブに移動の際は、そのデータグリッド
        switch (tabControl.SelectedTab.Name){
            case "tabBase": dgrBase.Select(); break;
            case "tabDest": dgrDest.Select(); break;
            case "tabComp": dgrComp.Select(); break;
        }
        //処理中タブの時だけ画面サイズを小さくし、他の時は元に戻す。
        this.Size = tabControl.SelectedTab.Name == "tabInProc" ? new Size(230, 85) : cGeneralWindowSize;
    }
    #endregion//ＵI
//□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□□
    #region 保存・再現
    private void btnSave_Click(object sender, EventArgs e) {
        StreamWriter lCSV = null;
        try{
            if (dgrBase.RowCount == 0 || dgrBase.ColumnCount == 0) return;
            //ファイル保存ダイアログを出す。参考：https://dobon.net/vb/dotnet/form/savefiledialog.html
            SaveFileDialog sfd = new SaveFileDialog();
            var now = DateTime.Now;
            sfd.FileName = "StatisticsSaveFile"
                + now.Year  .ToString() + "年"
                + now.Month .ToString().PadLeft(2, '0') + "月"
            　　+ now.Day   .ToString().PadLeft(2, '0') + "日"
                + now.Hour  .ToString().PadLeft(2, '0') + "時"
                + now.Minute.ToString().PadLeft(2, '0') + "分"
                + now.Second.ToString().PadLeft(2, '0') + "秒" + ".csv";
            sfd.InitialDirectory = "./";
            sfd.Filter = "";
            sfd.FilterIndex = 2;
            sfd.Title = "PictureStttSave";
            sfd.RestoreDirectory = true;
            if (sfd.ShowDialog() != DialogResult.OK) return;
            //直接ＣＳＶオブジェクトに書いていくのは途中でエラーした場合の対処的に良くないため、
            //一旦文字列変数に貯え、生成処理が全て成功してから書く。
            StringBuilder lSb = new StringBuilder();
            //データグリッド以外
            lSb.AppendLine(  "CompMethod," + (lblCompMethod_Base.BackColor == Color.Khaki ? "Base" : "Dest"));
            lSb.AppendLine("ProcPriority," + cmbProcPriority.SelectedItem.ToString());
            lSb.AppendLine(   "Threshold," + txtThreshold.Text);
            lSb.AppendLine(    "StttOmit," + cmbStttOmit.SelectedItem.ToString());
            lSb.AppendLine( "StttSection," + cmbStttSection.SelectedItem.ToString());
            lSb.AppendLine(    "BasePath," + txtBasePath.Text);
            lSb.AppendLine(    "DestPath," + txtDestPath.Text);
            lSb.AppendLine(    "BaseRoot," + lblBaseRoot.Text);
            lSb.AppendLine(    "DestRoot," + lblDestRoot.Text);
            //各データグリッド
            fGridToStringBuilder(dgrBase, ref lSb);
            fGridToStringBuilder(dgrDest, ref lSb);
            fGridToStringBuilder(dgrComp, ref lSb);            
            //書込と後処理
            lCSV = new StreamWriter(sfd.FileName, false, Encoding.UTF8);
            lCSV.Write(lSb.ToString());
            lCSV.Close();
            lCSV.Dispose();
        } catch (Exception ex) {
            fErrCatch("ＣＳＶ書込時にエラー", ex);
        } finally {
            if (lCSV != null) try { lCSV.Close();   } catch { };//ごり押しでファイルオブジェクトを開放する。
            if (lCSV != null) try { lCSV.Dispose(); } catch { };//〃
        }
    }
    //データグリッド内容保存処理を共通化
    private void fGridToStringBuilder(DataGridView aGrid, ref StringBuilder aSb) {
        try {
            //[ ]付きワードは、各データグリッドのデータ先頭の目印。
            aSb.AppendLine("[" + aGrid.Name + "]");
            if (aGrid.RowCount < 1 || aGrid.ColumnCount < 1) return;
            //列名を書く
            for (int col = 0; col < aGrid.ColumnCount; col++) {
                if (col != 0) aSb.Append(",");
                aSb.Append(aGrid.Columns[col].HeaderText);
            }
            aSb.AppendLine("");
            //データを書く
            for (int row = 0; row < aGrid.RowCount; row ++){
                for (int col = 0; col < aGrid.ColumnCount; col++) {
                    if (col != 0) aSb.Append (",");
                    aSb.Append(aGrid.Rows[row].Cells[col].Value.ToString());
                }
                aSb.AppendLine("");
            }
        } catch (Exception ex) {
            fErrCatch(aGrid.Name + "保存時にエラー", ex);
        }
    }
    //再現処理全般
    private void btnReproduce_Click(object sender, EventArgs e) {
        StreamReader lStream = null;
        StringReader lRead = null;
        try {
            fControlInit();
            lStream = new StreamReader(txtBasePath.Text, Encoding.Default);
            //読込結果は、すぐに S t r i n g Readerに移してファイルを閉じる。
            //※StreamReader利用中にエラーが起きると、ファイルアクセスがおかしくなりやすい。
            lRead = new StringReader(lStream.ReadToEnd());
            lStream.Close();
            lStream.Dispose();
            //データグリッド以外の再現。
            string[] lEachLine;
            while(lRead.Peek() != -1) {
                lEachLine = lRead.ReadLine().Split(',');
                if (lEachLine.Length < 1 || lEachLine[0] == "") continue;
                if (lEachLine[0] == "[dgrBase]") break;//この記述の場合、次処理に移る。

                switch (lEachLine[0]) {
                    case "CompMethod":
                        if (lEachLine[1] == "Base") {
                            lblCompMethod_Base.BackColor = Color.Khaki;
                            lblCompMethod_Dest.BackColor = Color.LightGray;
                        } else {
                            lblCompMethod_Base.BackColor = Color.LightGray;
                            lblCompMethod_Dest.BackColor = Color.Khaki;
                        }
                        break;
                    case "ProcPriority":fSetComboBySetting(cmbProcPriority, lEachLine[1]); break;
                    case "Threshold":txtThreshold.Text = lEachLine[1]; break;
                    case "StttOmit": fSetComboBySetting(cmbStttOmit, lEachLine[1]); break;
                    case "StttSection": fSetComboBySetting(cmbStttSection, lEachLine[1]); break;
                    case "BasePath":txtBasePath.Text = lEachLine[1]; break;
                    case "DestPath":txtDestPath.Text = lEachLine[1]; break;
                    case "BaseRoot":lblBaseRoot.Text = lEachLine[1]; break;
                    case "DestRoot":lblDestRoot.Text = lEachLine[1]; break;
                    default:break;
                }
            }
            //データグリッドの再現
            fReproduceDatagrid(ref dgrBase, ref lRead, "[dgrDest]");
            fReproduceDatagrid(ref dgrDest, ref lRead, "[dgrComp]");
            fReproduceDatagrid(ref dgrComp, ref lRead, "dummy");

            fAfterProc();
        }
        catch (Exception ex) {
            fErrCatch("設定ファイル読み込み時にエラー", ex);
            if (lStream != null) {
                try { lStream.Close()  ; } catch { }
                try { lStream.Dispose(); } catch { }
            }
        }
    }
    //データグリッド内容の再現
    private void fReproduceDatagrid(ref DataGridView aGrid, ref StringReader sReader, string aNext) {
        string[] lEachLine;
        while (sReader.Peek() != -1) {
            lEachLine = sReader.ReadLine().Split(',');
            if (lEachLine[0] == aNext) return;//この記述は次処理の目印。次処理に移る。
            if(lEachLine[0] == "No.") {//この場合は見出し
                if (aGrid.Name != "dgrComp") fSetStttCol(ref aGrid);//※比較結果グリッドは再構成不要
            } else {//上記以外はデータ内容
                aGrid.Rows.Add();
                for (int i = 0; i < lEachLine.Count(); i++) {
                    //右記のセルは小数点４桁に補正 -> 比較グリッドの２列目と、他グリッドの３列目以降。
                    if (   (aGrid.Name == "dgrComp" && i == 1)
                        || (aGrid.Name != "dgrComp" && i >= 2) )
                    {
                        float temp;
                        float.TryParse(lEachLine[i], out temp);
                        lEachLine[i] = temp.ToString("0.0000");
                    }
                    aGrid.Rows[aGrid.Rows.Count - 1].Cells[i].Value = lEachLine[i];
                }
            }
        }
    }
    #endregion//保存・再現
}
//}※namespaceは省略
